---
title: Network Information API
slug: Web/API/Network_Information_API
tags:
  - API
  - Experimental
  - Network Information API
  - Reference
  - WebAPI
---
<p>{{DefaultAPISidebar("Network Information API")}}{{SeeCompatTable}}</p>

<p>The Network Information API provides information about the system's connection in terms of general connection type (e.g., 'wifi', 'cellular', etc.). This can be used to select high definition content or low definition content based on the user's connection. The entire API consists of the addition of the {{domxref("NetworkInformation")}} interface and a single property to the {{domxref("Navigator")}} interface: {{domxref("Navigator.connection")}}.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="Detect_connection_changes">Detect connection changes</h3>

<p>This example watches for changes to the user's connection.</p>

<pre class="brush: js notranslate">var connection = navigator.connection || navigator.mozConnection || navigator.webkitConnection;
var type = connection.effectiveType;

function updateConnectionStatus() {
  console.log("Connection type changed from " + type + " to " + connection.effectiveType);
  type = connection.effectiveType;
}

connection.addEventListener('change', updateConnectionStatus);
</pre>

<h3 id="Preload_large_resources">Preload large resources</h3>

<p>The connection object is useful for deciding whether to preload resources that take large amounts of bandwidth or memory. This example would be called soon after page load to check for a connection type where preloading a video may not be desirable. If a cellular connection is found, then the <code>preloadVideo</code> flag is set to <code>false</code>. For simplicity and clarity, this example only tests for one connection type. A real-world use case would likely use a switch statement or some other method to check all of the possible values of {{domxref("NetworkInformation.type")}}. Regardless of the <code>type</code> value you can get an estimate of connection speed through the {{domxref("NetworkInformation.effectiveType")}} property.</p>

<pre class="brush: js notranslate">let preloadVideo = true;
var connection = navigator.connection || navigator.mozConnection || navigator.webkitConnection;
if (connection) {
  if (connection.effectiveType === 'slow-2g') {
    preloadVideo = false;
  }
}</pre>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("NetworkInformation")}}</dt>
 <dd>Provides information about the connection a device is using to communicate with the network and provides a means for scripts to be notified if the connection type changes. The <code>NetworkInformation</code> interfaces cannot be instantiated. It is instead accessed through the {{domxref("Navigator")}} interface.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Network Information', '', 'Network Information API')}}</td>
   <td>{{Spec2('Network Information')}}</td>
   <td>Initial specification</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="NetworkInformation">NetworkInformation</h3>

<p>{{Compat("api.NetworkInformation")}}</p>

<h3 id="Navigator.connection">Navigator.connection</h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.Navigator.connection")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{spec("https://w3c.github.io/netinfo/", "Network Information API Specification", "ED")}}</li>
 <li><a href="/en-US/docs/Online_and_offline_events">Online and offline events</a></li>
 <li>{{domxref("Navigator.connection", "window.navigator.connection")}}</li>
</ul>
